#include "FETVGSID.h"

FETVGSID::FETVGSID(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int FETVGSID::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
    PegRect rectangle;
 
 	PegPrompt* label_1 = new PegPrompt(margin, 30, width, "Vg(V):",0,wStyle);
	Vg = new CPPegString(margin+50,30,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Vg);
	AddR(label_1);
	
 	PegPrompt* label_2 = new PegPrompt(margin, 45, width, "Vgsoff:",0,wStyle);
	Vgsoff = new CPPegString(margin+50,45,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Vgsoff);
	AddR(label_2);
	
 	PegPrompt* label_3 = new PegPrompt(margin, 60, width, "Iss(mA):",0,wStyle);
	Idss = new CPPegString(margin+50,60,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Idss);
	AddR(label_3);
	
 	PegPrompt* label_4 = new PegPrompt(margin, 75, width, "Rs(ohm):",0,wStyle);
	Rs = new CPPegString(margin+50,75,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Rs);
	AddR(label_4);
	
     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(50, 100, 115, 115);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Calcular!", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
	Vgs = new PegPrompt(margin, 130, width, "",0,wStyle);
	Id = new PegPrompt(margin, 145, width, "",0,wStyle);
	gm = new PegPrompt(margin, 160, width, "",0,wStyle);

	AddR(Vgs);
	AddR(Id);
	AddR(gm);
	
 	
	return 0;
}

void FETVGSID::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED FETVGSID::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
             Calcula();
		}
		break;
		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD FETVGSID::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void FETVGSID::Calcula()
{
    int precisio = 6;
    int maxiters = 50;
    int i;
    OBCD Vs, Vs_aux, aux, aux2;
    
    Cal_setn_OBC(0,&Vs);

    for(i=0;i<maxiters;i++)
    {
        Vs_aux = Calcula_Id(Vs);
        aux = Vs;
        aux2 = Vs_aux;
        Vs = Vs_aux; 
        Cal_cintx_OBC(&aux,precisio);
        Cal_cintx_OBC(&aux2,precisio); 
        if(aux == aux2) break;
    }       
    
    aux = IdOBCD;
    Cal_cintx_OBC(&aux,4);
    Id -> DataSet("Id = "+CPString(aux)+" A");
    
    aux = CPExpression(Vg->DataGet());
    Cal_sub_OBC(&aux,&Vs);
    Cal_cintx_OBC(&aux,4);
    Vgs -> DataSet("Vgs = "+CPString(aux)+" V");

    aux = CPExpression(Idss->DataGet());
    ExecuteToOBCD("1000",aux2);
    Cal_div_OBC(&aux,&aux2);
    aux2 = IdOBCD;
    Cal_div_OBC(&aux2,&aux);   
    Cal_sqrt_OBC(&aux2);
    Cal_mul_OBC(&aux,&aux2);
    ExecuteToOBCD("-2",aux2);
    Cal_mul_OBC(&aux,&aux2);
    aux2 = CPExpression(Vgsoff->DataGet());
    Cal_div_OBC(&aux,&aux2);

    Cal_cintx_OBC(&aux,4);
    gm -> DataSet("gm = "+CPString(aux)+" S");
    
    Draw();
}   

OBCD FETVGSID::Calcula_Id(OBCD V_s)
{
    OBCD aux;
    IdOBCD = CPExpression(Vg->DataGet());
    Cal_sub_OBC(&IdOBCD,&V_s);
    aux = CPExpression(Vgsoff->DataGet());
    Cal_div_OBC(&IdOBCD,&aux);
    Cal_setn_OBC(1,&aux);
    Cal_sub_OBC(&aux,&IdOBCD);
    Cal_square_OBC(&aux);
    IdOBCD = CPExpression(Idss->DataGet());
    Cal_mul_OBC(&IdOBCD,&aux);
    ExecuteToOBCD("1000",aux);
    Cal_div_OBC(&IdOBCD,&aux);
    aux = CPExpression(Rs->DataGet());
    Cal_mul_OBC(&aux,&IdOBCD);
    return aux;    
}    

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
